program TestRate;

uses Crt, dsputil;

const
     Units:real = (14312800/12) / 65535;      { Ticks/second }
     TakeUnits = 20;
     FIFOread   = $300;
     FIFOstatus = $302;
     FIFOreset  = $304;

var
  Left,
  Right  : word;
  Timing : longint;
  TheTime: word absolute $40:$6C;
  StartT : word;
  EndT   : word;
  SamplingTime: longint;
  NewSamplingTime: longint;
  Difference: longint;
  Percentage: real;
  Sample    : word;

begin
  writeln('Please wait one second, determining sampling rate ....');
  Timing := 0;
  StartT := TheTime;
  repeat until TheTime>StartT;
  EndT := TheTime + TakeUnits;
  repeat
    Sample := portw[FIFOread];
  until (portw[FIFOstatus] and $01)=0;
  repeat until (portw[FIFOstatus] and $01)<>0;
  repeat
    Timing := Timing + 1;
    repeat
      Sample := portw[FIFOread];
    until (port[FIFOstatus] and $01)=0;
    repeat until (port[FIFOstatus] and $01)<>0;
  until TheTime>=EndT;
  SamplingTime := trunc(((Timing * Units) / TakeUnits)) div 2;
  NewSamplingTime := 0;
  if SamplingTime > 46000 then NewSamplingTime := 48000;
  if SamplingTime < 40000 then NewSamplingTime := 32000;
  if (SamplingTime < 46000) and (SamplingTime > 40000)
    then NewSamplingTime := 44100;
  Difference := abs(NewSamplingTime-SamplingTime);
  Percentage := Difference / (SamplingTime/100);
  if Percentage>10 then NewSamplingTime := SamplingTime;
  writeln('Sample time: ', NewSamplingTime, ' samples/s (measured:', SamplingTime,')');
  if Percentage<10 then writeln('Deviation  : ', Percentage:3:1,' %');
end.